/* Spectator Chat  - 2.0
 * -
 * This plugin allows spectators, ready roomers, and players in a team to
 * talk to each other (through global chat).  Team chat is still
 * restricted to going only to the player's team, rather than globally.
 *
 * cvars:
 * mp_spectator chat (default: 1)
 * Set this to 0 to disable the plugin on the fly.
 *
 * This plugin also auto disables itself when tournament mode is on.
 *
 * 1.0->2.0 changes: (1.0 was exclusive to modNS)
 *   o Made AMX Mod X 0.20 compatible (trivial)
 *   o Fixed bug where players entering an empty chat string would be sent.
 *   o Something else which I forgot, but I assure you, it was good!
 *
 */


#include <amxmodx>

new gmsgSayText
public plugin_init()
{
  register_plugin("Spectator Chat","1.0","Steve Dudenhoeffer")
  register_clcmd("say","handleSay")
  register_cvar("mp_spectatorchat","1")
  gmsgSayText=get_user_msgid("SayText")
}
pluginEnabled()
{
  // This plugin is disabled if mp_tournamentmode is > 0, or mp_spectatorchat is 0
  if (get_cvar_num("mp_tournamentmode") > 0 || get_cvar_num("mp_spectatorchat") == 0)
    return 0
  return 1
}
public handleSay(id)
{
  if (!pluginEnabled())
    return PLUGIN_CONTINUE

  new szText[180]
  new szBlah[180]
  // Block empty messages..
  read_argv(1,szBlah,179)
  if (read_argc() == 1 && szBlah[0] == '^0')
  {
    return PLUGIN_CONTINUE
  }

  for (new i=1;i<=read_argc();i++)
  {
    read_argv(i,szBlah,179)
    format(szText,179,"%s %s",szText,szBlah)
  }
  new szName[32]
  get_user_name(id,szName,31)
  // I don't know why, but the SayText text is enclosed in \02 and \10.
  new szColor[2]={2,0};
  new szLinefeed[2]={10,0};
  format(szText,179,"%s%s:%s%s",szColor,szName,szText,szLinefeed)
  new szSourceTeam[12]
  get_user_team(id,szSourceTeam,11)
  new team = szSourceTeam[0]
  new szTargetTeam[12]
  for (new j=1;j<=get_maxplayers();j++)
  {
    if (is_user_connected(j))
    {
      get_user_team(j,szTargetTeam,11)
      if (team == 's') // "spectatorteam"
      {
        // The player writing this text is a spectator.  Send his chat to everybody who is in a team, and who is in the rr.
        if (szTargetTeam[0] == 'a' || szTargetTeam[0] == 'm' || szTargetTeam[0] == 'u')
        {
          // Target player is on a team, or in the ready room.
          message_begin(MSG_ONE,gmsgSayText,{0,0,0},j)
          write_byte(id)
          write_string(szText)
          write_string("")
          message_end()
        }
      }
      else if (team == 'm' || team == 'a') // marine[1/2]team || alien[1/2]team
      {
        // The player writing this text is on a team.  Send his chat to everybody who is in the ready room ONLY.
        if (szTargetTeam[0] == 'u')
        {
          // Target player is not in a team.
          message_begin(MSG_ONE,gmsgSayText,{0,0,0},j)
          write_byte(id)
          write_string(szText)
          write_string("")
          message_end()
        }
      }
      else if (team == 'u') // undefinedteam -- readyroom
      {
        // The player writing the text is in the ready room, send it to everybody else who is not in the ready room.
        if (szTargetTeam[0] != 'u')
        {
          // Target player is not in ready room.
          message_begin(MSG_ONE,gmsgSayText,{0,0,0},j)
          write_byte(id)
          write_string(szText)
          write_string("")
          message_end()
        }
      }
    }
  }
 
  return PLUGIN_CONTINUE
}